



%%
%  extractHybrid computes the four hybrid matrices dependent on
%  freq,magnitude and phase
%
%%

function [h11 h12 h21 h22] = extractHybrid(Z,C,s)

% Hybrid elements are defined for positions (below its recalculated)
% Ze = Z{1};
% Zh = Z{2};
sZs = Z{3};
sZm = Z{4};
% clear Z
C1 = C{1};
C2 = C{2};
C3 = C{3};
C4 = C{4};
C5 = C{5};
C6 = C{6};
Cs = C{7};
Cm = C{8};

% clear C
hden = (sZs+Cs).*(1+C6)-C3.*C4;

h11x = hden.^-1.*((sZs + Cs).*(sZm+Cm)+C1.*C4);
h12 = hden.^-1.*(-(sZs+Cs).*C2 + C4.*(1+C5));
h21 = hden.^-1.*((sZm + Cm).*C3 + C1.*(1+C6));
h22x = hden.^-1.*((1+C5).*(1+C6)-C2.*C3);

h11 = h11x./s;
h22 = h22x.*s;
return

