function implOwnStabCrit(action)
global data

switch action
    case 'define'
        set(data.handles.defineElement,'String','Defining own stability criterion'); drawnow;
        
        % Declaration Pop-up in the middle of the screen
        h = figure;
        data.dynamics.temp.h = h;
        hDesiredSize = [520, 160];
        set(h,'Resize','off','MenuBar','none','ToolBar','none','NumberTitle','off','Name',...
            ['Define own Stability Criterion'],'Position',centerPopUp(hDesiredSize),...
            'Units','normalized','Color',[.9 .9 .9],'WindowStyle','modal');
        
        % Declaration Cancel button
        hcancel = uicontrol(h,'Style','pushbutton','String','Cancel','Units','normalized',...
            'Position',[.25 .06 .2 .2],'Backgroundcolor',data.colourbutton,'FontSize',[12],...
            'Callback','global data; closePopUp(data.dynamics.temp.h); clear data;');
        
        % Declaration Define button
        hdefine = uicontrol(h,'Style','pushbutton','String','Define','Units','normalized',...
            'Position',[.55 .06 .2 .2],'Backgroundcolor',data.colourbutton,'FontSize',[12],...
            'Callback',@saveFunction);
        
        
        givefilename = uicontrol(h,'Style','text','String',...
            'Name of function file including your stabilitycriterion with input [{C1,C2,C3,C4,C5,C6,Cs,Cm},{Ze,Zh,Zs,Zm},s]',...
            'Units','normalized','Position',[.15 .6 .7 .3],'Backgroundcolor',...
            [.9 .9 .9]);
        
        m = uicontrol(h,'Style','text','String','.m',...
            'Units','normalized','Position',[.75 .45 .1 .15],'Backgroundcolor',...
            [.9 .9 .9]);
        
        data.dynamics.temp.funcName = uicontrol(h,'Style','edit','String','funcOwnStabCrit',...
            'Units','normalized','UserData','',...
            'Backgroundcolor',[1 1 1],'Position',[.30 .5 .45 .15]);
        
    case 'evaluate'
        
end




return

function saveFunction(varargin)
global data

data.stabilitycriterionFunction = get(data.dynamics.temp.funcName,'String');

closePopUp(data.dynamics.temp.h);
set(data.handles.defineElement,'String',' '); drawnow;



return

