function plot3Ddiagram(action,hObject,eventdata,handles)
global data;

%% 3D plot
% set(data.handles.Diagram3D,'View',[45 45],'XTick',[],'YTick',[],'ZTick',[])
%
% set(get(data.handles.Diagram3D,'ZLabel'),'String',...
%     ['Frequency [','',']']);
% set(get(data.handles.Diagram3D,'XLabel'),'String',...
%     ['Magnitude [','',']']);
% set(get(data.handles.Diagram3D,'YLabel'),'String',...
%     ['Phase [','',']']);
data.stepOfAction(1,1) = 1;
data.stepOfAction(1,2) = 2;

set(data.handles.defineElement,'string',...
    ['Stability Mapping: Creating 3D Mag-Phase-Freq Grid (Step ',num2str(data.stepOfAction(1,1)),...
    ' of ',num2str(data.stepOfAction(1,2)),').']); drawnow;
data.stepOfAction(1,1) = data.stepOfAction(1,1) + 1;

mapping('3D');

set(data.handles.defineElement,'string',...
    ['Plotting: 3D Mag-Phase-Freq Grid (Step ',num2str(data.stepOfAction(1,1)),...
    ' of ',num2str(data.stepOfAction(1,2)),').']); drawnow;
data.stepOfAction(1,1) = data.stepOfAction(1,1) + 1;

stabChange = data.stabilityproperties.stabChange;
Freq  = data.parameters.Freq;
Mag   = data.parameters.Mag;
Phase = data.parameters.Phase;

nFreq = length(Freq);
nMag  = length(Mag);
nPhase = length(Phase);

plotMag3D = [];
plotFreq3D = [];
plotPhase3D = [];

j = 1;
figure
for iW = 1:1:nFreq
    for iM = 1:1:nMag
        for iP = 1:1:nPhase
            if(stabChange(iW,iM,iP))
                plotFreq3D(j) = Freq(iW);
                plotMag3D(j) = Mag(iM);
                plotPhase3D(j) = Phase(iP);
                % plot3(Mag(iM),Phase(iP),Freq(iW),'s','MarkerFaceColor',0.2*ones(3,1)+iW/nFreq*0.6,...
                %         'LineWidth',3);hold on;
                markerface(j,:) = 0.2*ones(1,3)+iW/nFreq*0.6;
                j = j + 1;
                
            end
        end
    end
end

data.plot.Data.Mag3D = plotMag3D;
data.plot.Data.Phase3D = plotPhase3D;
data.plot.Data.Freq3D = plotFreq3D;
data.plot.scaleMag3D = [60 80 100 120];
data.plot.scalePhase3D = [-180 -90 0 90 180];
data.plot.scaleFreq3D = [0.01 0.1 1 10];

plot3(plotMag3D,plotPhase3D,plotFreq3D,'s','Color',[.6 .6 .6],'LineWidth',3);hold on;%'MarkerFaceColor',[0.6 0.6 0.6],...
%         'MarkerEdgeColor','none','LineWidth',3);hold on;
zlabel('Frequency [Hz]')
xlabel('Magnitude [dB]')
ylabel('Phase [degree]')

plotController3D();

set(data.handles.defineElement,'string',''); drawnow;
return


function plotController3D()

%%
%
%
%%
global data;

k = 1;
showWhichController = [];
for i = 1:1:length(data.plotController)
    if(data.plotController(i) == 1)
        showWhichController(k) = i;
        k = k + 1;
    end
end
if(~isempty(showWhichController))
    for i = 1:1:length(showWhichController)
        j = showWhichController(i);
        
        Freq  = data.parameters.Freq;
        Controller = data.symController{j};
        
        scaleMag = data.plot.scaleMag2D;
        scaleFreq = data.plot.scaleFreq2D;
        if(data.discretisation.unitsFreq.Value == 1)
            if(data.plot.unitsFreq.Value == 1)
                s = 1j.*2.*pi.*Freq;
                gainFreq = 1;
            else
                Freq = 2.*pi.*Freq;
                s = 1j.*Freq;
                gainFreq = 2*pi;
            end
        else
            if(data.plot.unitsFreq.Value == 1)
                s = 1j.*Freq;
                Freq = Freq./(2*pi);
                gainFreq = 1/(2*pi);
            else
                s = 1j.*Freq;
                gainFreq = 1;
            end
        end
        
        if(isnumeric(Controller))
            if(length(data.Controller{j})>1)
                Controller = data.Controller{j};
            else
                Controller = data.Controller{j}*ones(size(data.parameters.Freq));
            end
        else
            Controller = eval(Controller);
        end
        
        Mag = db(Controller);
        if(data.discretisation.unitsPhase.Value == 1)
            if(data.plot.unitsPhase.Value == 1)
                Phase = angle(Controller)/(2*pi)*360;
                gainPhase = 1;
                scalePhase = data.plot.scalePhase2D;
            else
                Phase = angle(Controller);
                gainPhase = (2*pi)/360;
                scalePhase = data.plot.scalePhase2D.*2.*pi./360;
                
            end
        else
            if(data.plot.unitsPhase.Value == 1)
                Phase = angle(Controller).*360./(2.*pi);
                gainPhase = 360/(2*pi);
                scalePhase = data.plot.scalePhase2D.*360./(2.*pi);
            else
                Phase = angle(Controller);
                gainPhase = 1;
                scalePhase = data.plot.scalePhase2D;
            end
        end
        
        plot3(Mag,Phase,Freq,'k','LineWidth',3)
        
    end
end

return



